import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styles from './index.module.scss';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var ServiceCardImage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ServiceCardImage, _React$Component);

  function ServiceCardImage() {
    _classCallCheck(this, ServiceCardImage);

    return _possibleConstructorReturn(this, _getPrototypeOf(ServiceCardImage).apply(this, arguments));
  }

  _createClass(ServiceCardImage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // These imports are only needed client-side and allow for lazy-loading images. They should
      // be changed to `import()` once Gatsby 2 launches. We're currently limited by the version
      // of Webpack that Gatsby uses.
      // https://github.com/gatsbyjs/gatsby/issues/461
      // https://github.com/thumbtack/thumbprint/issues/960

      /* eslint-disable global-require */
      require('lazysizes/plugins/unveilhooks/ls.unveilhooks');

      require('lazysizes'); // `ls.attrchange.js` re-renders the image when the props change:
      // https://github.com/aFarkas/lazysizes/issues/339


      require('lazysizes/plugins/attrchange/ls.attrchange.js');
      /* eslint-enable */

    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          url = _this$props.url,
          alt = _this$props.alt;
      return React.createElement("div", {
        className: "".concat(styles.image, " lazyload"),
        "data-bg": url,
        role: "img",
        "aria-label": alt
      });
    }
  }]);

  return ServiceCardImage;
}(React.Component);

function ServiceCardTitle(_ref) {
  var children = _ref.children;
  return React.createElement("div", {
    className: styles.title,
    title: children
  }, children);
}

function ServiceCardDescription(_ref2) {
  var _classNames;

  var iconColor = _ref2.iconColor,
      icon = _ref2.icon,
      children = _ref2.children;
  return React.createElement("div", {
    className: classNames(styles.descriptionWrap, (_classNames = {}, _defineProperty(_classNames, styles.iconBlue, iconColor === 'blue'), _defineProperty(_classNames, styles.iconGreen, iconColor === 'green'), _classNames))
  }, icon, React.createElement("div", {
    className: styles.description
  }, children));
}
/**
 * @default
 */


function ServiceCard(_ref3) {
  var url = _ref3.url,
      children = _ref3.children;
  return React.createElement("a", {
    href: url,
    className: styles.root
  }, children);
}
ServiceCard.propTypes = {
  /**
   * URL pointing to the card link destination.
   */
  url: PropTypes.string,

  /**
   * Accepts content of `ServiceCardImage`, `ServiceCardTitle`, `ServiceCardDescription`.
   */
  children: PropTypes.node.isRequired
};
ServiceCard.defaultProps = {
  url: undefined
};
ServiceCardImage.propTypes = {
  /**
   * URL pointing to image to be displayed.
   */
  url: PropTypes.string.isRequired,

  /**
   * Image alt tag that's passed to `aria-label` for better accessibility.
   */
  alt: PropTypes.string
};
ServiceCardImage.defaultProps = {
  alt: undefined
};
ServiceCardTitle.propTypes = {
  /**
   * Service title.
   */
  children: PropTypes.node.isRequired
};
ServiceCardDescription.propTypes = {
  /**
   * Service description or other service info.
   */
  children: PropTypes.node.isRequired,

  /**
   * Icon from [Thumbprint Icons](/api/icons/) to render within the
   * service card. It must be one of the small icons.
   */
  icon: PropTypes.node,

  /**
   * Color options for icon. Only required if you want to override default color.
   */
  iconColor: PropTypes.oneOf(['blue', 'green'])
};
ServiceCardDescription.defaultProps = {
  icon: undefined,
  iconColor: 'blue'
};

export default ServiceCard;
export { ServiceCardDescription, ServiceCardTitle, ServiceCardImage };
//# sourceMappingURL=index.es.js.map
